Schema Modeler

Data Abstract Schema Modeler
Contents | Index
Next
Schema Modeler

Schema Modeler is the RAD design tool for Data Abstract that lets you define your data access and create your Schemas and abstract the underlying database structure separately from the data interface that your client and business tier are programmed against.

The Schema Modeler is shared between the Delphi and .NET editions of Data Abstract. It provides a consistent approach to working with Schemas regardless of the platform or platforms for which you are developing.

Launching Schema Modeler

Schema Modeler can be invoked in several ways:

  • By launching it directly via the "RemObjects Data Abstract" Start menu entry
  • By double-clicking a .daSchema file in Windows Explorer
  • For .NET, by double-clicking on the .daSchema in the Visual Studio Solution Explorer
  • For Delphi by double-clicking a TDASchema component in the Delphi IDE or selecting Edit Schema from it's context menu.

Schema Modeler will also run as part of the New Project Guide Wizard when creating a new Data Abstract application using the provided templates.

Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.
What do you think about this topic? Send feedback!


Schema Modeler Overview

Previous | Up | Next
Schema Modeler Overview
Schema Modeler | See Also

After launching Schema Modeler with a schema, you will see a view similar to the following, showing four panes docked to the left and right of the main window, and a large middle pane showing the Welcome Page.

Schema Modeler Application Layout

The Schema Modeler basically consists of 5 elements:

Along the left side, you see docked windows with the Data Tables and Commands panes, and along the right side you see the Connections pane and the Data Explorer. The layout has been designed so that client access is shown on the left and server only on the right.

You can drag and float these panes to other locations, to best adjust Schema Modeler to the way you work.

The center of the Schema Modeler window contains the Detail pane. Depending on which items you select in the detail pane or from the toolbar or menu, you will see a different view here. These views contain:

  • Data Table Details : by selecting a Data Tables in the left hand pane
  • Command Details : by selecting a Command in the left hand pane
  • Connection Details : by selecting a Connection in the right hand pane
  • Relationships View: by clicking on the Relationships button in the toolbar
  • Data Dictionary Editor : by clicking on the Data Dictionary button in the toolbar
  • Update Rules View: by clicking on the Update Rules button in the toolbar
  • Diagramming and Modeling Support: by clicking on the Diagrams button in the toolbar
  • Welcome Page : on startup and is also accessible via the Help | Show Welcome Page menu item
Notes

Delphi Notes:

  1. If the Data Dictionary button is disabled, it is because the Schema Modeler was invoked from within Data Abstract and the Schema's DataDictionary property is not assigned to a TDADataDictionary component.
  2. If the Diagrams button is disabled, it is because the Schema Modeler was invoked from within the Delphi IDE and there is no TDADiagrams component linked by the Schema.
See Also

Online articles:

DA03 - Introduction to Schemas

DA14 - Introducing Diagramming with Data Abstract

Group

Schema Modeler

Links
Schema Modeler, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Data Tables Pane

Data Tables Pane
Schema Modeler | See Also

The Data Tables pane lists all Data tables that are defined in your Schema.

A data table represents a rowset of data that will be retrieved and worked with by your Data Abstract application. A data table mustn't necessarily be backed by a physical table in your database, the data can come from either a table, a view or a custom query that might for example join multiple tables or calculate live data.

There are two ways to create a new data table for your schema:

  1. Press the "New Data Table" button in the pane's toolbar, and then fill in the details for your table by hand
  2. Drag a table from Data Explorer to the Data Tables pane and select "Create New Data Table":

The Schema Modeler will automatically create a new data table (in this case "Categories") for you, and set it up accordingly (it will create persistent field definitions for all fields, as well as provide a default SQL query to select the data).

You can then use the Data Table Details view to make manual adjustments to the new dataset, if needed.

Notes

The Create New Data Table and Delta-Commands option in the screenshot will create additional Commands for you in the Commands Pane, to be used for INSERTING, UPDATING and DELETING data.

These created SQL commands will be identical to those that are auto-generated by BusinessProcessor, so in general you will not need to create them. But if you are planning to use custom queries for updating data, these commands provide a good starting point.

See Also

Commands Pane Connections Pane Data Explorer SQL Editor Diagramming and Modeling Support

Group

Schema Modeler

Links
Schema Modeler, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Commands Pane

Commands Pane
Schema Modeler | See Also

The Commands pane lists all Commands that are defined in your Schema.

A Command represents an action your application will want to execute on the database. This can be calling a stored procedure, Inserting/Updating/Deleting records or running any kind of custom query that performs, for example, data manipulations.

There are three ways to create a new Command for your schema:

  1. Press the New Command button in the pane's toolbar and then fill in the details for your command by hand.
  2. Drag a Stored Procedure from the Data Explorer to create a command that will call this stored procedure.
  3. Drag a dataset from Data Tables pane to the Command pane and select "Create Delta Commands for Data Table" to create three Insert/Update/Delete commands for the data table:

After the Schema Modeler has created the new command or commands (in this case "Insert_Customer", "Update_Customer" and "Delete_Customer"), you can then use the Command Details view to make manual adjustments to the new commands or modify their statements.

Notes

You will only need to create INSERT/UPDATE/DELETE commands if you then wish to modify them (i.e. treat them as the base for custom SQL you are going to write), since the BusinessProcessor can automatically generate default statements at runtime when updating data.

See Also

Data Tables and Connections panes

Data Explorer

SQL Editor

Diagramming and Modeling Support

Group

Schema Modeler

Links
Schema Modeler, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Detail Pane

Detail Pane
Schema Modeler

The center of the Schema Modeler window contains the Detail Pane. Depending on which items you select in the other panes and the menu, you will see a different view here. These views are displayed:

  • Data Table Details : by selecting a Data Table in the left hand pane
  • Command Details : by selecting a Command in the left hand pane
  • Connection Details : by selecting a Connection in the right hand pane
  • Relationships View: by clicking on the Relationships button in the toolbar
  • Data Dictionary Editor : by clicking on the Data Dictionary button in the toolbar
  • Update Rules View: by clicking on the Update Rules button in the toolbar
  • Diagramming and Modeling Support: by clicking on the Diagrams button in the toolbar
  • Welcome Page : on startup and is also accessible via the Help | Show Welcome Page menu item
Group

Schema Modeler

Links
Schema Modeler
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Data Table Details

Data Table Details
Detail Pane

You will see the Data Table Details view when selecting a Data Table in the left hand pane of the Schema Modeler.

This view allows you to adjust the properties of a data table, including the fields that make up its rowset, the parameters needed to retrieve the dataset (if any) and the statements used to obtain the rowset from the physical database.

Group

Detail Pane

Links
Detail Pane
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Command Details

Command Details
Detail Pane

You will see the Command Details view when selecting a Command in the left hand pane of the Schema Modeler.

This view allows you to adjust the properties of a command, including the parameters needed to execute the command (if any) and the statements used to run it on the database system.

Group

Detail Pane

Links
Detail Pane
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Connection Details

Connection Details
Detail Pane

You will see the Connection Details view when selecting a Connection in the right hand pane of the Schema Modeler.

This view allows you to adjust the properties of a connection, such as the name, the actual connection string, and whether the connection is the default connection.

Group

Detail Pane

Links
Detail Pane
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Relationships View

Relationships View
Detail Pane | See Also

The Master/Detail Relationships view can be activated by clicking on the Relationships button in the Schema Modeler toolbar, and allows you to edit and maintain the master/detail relationships and primary/foreign key connections between your data tables.

See Also

Diagramming and Modeling Support help topic

Group

Detail Pane

Links
Detail Pane, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Data Dictionary Editor

Data Dictionary Editor
Detail Pane

Delphi Note: For the Data Dictionary Editor to be available when the Schema Modeler is invoked from within the IDE, the Schema's DataDictionary property needs to be assigned to a TDADataDictionary component, which can be dropped from the Data Abstract component palette.

Display the Data Dictionary Editor view by clicking on the Data Dictionary button in the Schema Modeler toolbar:

Group

Detail Pane

Links
Detail Pane
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Update Rules View

Update Rules View
Detail Pane

Display the Update Rules view by clicking on the Update Rules button in the Schema Modeler toolbar:

The Update rules view only occupies the top half of the center pane and this allows you to view the fields of a datatable underneath.

Update rules control the processing of a delta packet on the server. If no rules are defined, items in the delta packet are processed sequentially. For master/detail relationships that you wish to update in a single server round trip, it is important to get the processing order correct.

For a master/detail update in a single shot, you need four rules in the following order:

DataTable | Commands
master | Insert + Update
detail | Insert + Update
detail | Delete
master | Delete

Inserts and Updates can be combined because the delta packet will not contain an Insert after an Update for a particular item.

Once update rules are in place, they are applied sequentially to the delta packet.

Group

Detail Pane

Links
Detail Pane
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Diagramming and Modeling Support

Diagramming and Modeling Support
Detail Pane | See Also

The Diagrams view can be activated via the Diagrams menu item or by right-clicking on any of the Datasets and by selecting New Diagram.

Diagrams allow you to visually layout related tables in a Entity Relationship diagram and visualize and create master/detail connections between your tables:

You can drag more data tables from the Data Tables Pane to add them to the diagram.

Dragging one or more tables from the Data Explorer to the diagram will automatically add it to the list of data tables defined in the Schema Modeler's left panel, and will also automatically import relationship data between those tables, if the database driver provides relationship meta data.

Creating Master/Detail Relationships

Adding links can be achieved by clicking on a dataset field in the diagram and by dragging it to the appropriate field in another dataset. A link can also be modified by double-clicking anywhere on the connection line representing the link. In both cases, the following dialog will display, allowing you to adjust the relationship.

Notes

Delphi Note: For Diagramming support to be available when the Schema Modeler is invoked from within the IDE, the Schema's Diagrams property needs to refer to a TDADiagrams component, which can be dropped from the Data Abstract component palette.

See Also

Relationships View help topic

Group

Detail Pane

Links
Detail Pane, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Schema Modeler Welcome Page

Schema Modeler Welcome Page
Detail Pane

The Welcome Page is automatically shown on startup and is also accessible via the Help|Show Welcome Page menu item.

Group

Detail Pane

Links
Detail Pane
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Connections Pane

Connections Pane
Schema Modeler | See Also

The Connections pane lists all database connections that are defined for your project.

Your Data Abstract applications may be built to target multiple databases with one code base, and you can use the Connections pane to define multiple connections. These connections may point to separate copies of the same database structure (say, your local test database and the live database used on the production server), or could represent different database types your applications is targeted against (say, one Microsoft SQL Server based database, and one using Borland InterBase).

You can create a new connection by pressing the " New Connection" button, which will bring up the Connection Wizard dialog to assists you in building a connection string:

Depending on your selection for Driver Name, a different number of steps will appear in the the dialog and the help panel provided is context sensitive. For example, when you set the Driver Name to NexusDB, you get the following:

Once you press Ok, the new connection will be created, and you can configure it further via the Connection Details view (see Connection Details in the Detail Pane, especially for the note about the Default property).

You can also use the Data Explorer to browse the content of the database, or click the Check Connections button to verify all the connections you have defined.

Notes

The list of available driver names will depend on the installed editions of Data Abstract.

See Also

Data Tables and Commands panes,

Data Explorer, SQL Editor, Diagramming and Modeling Support

Group

Schema Modeler

Links
Schema Modeler, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Data Explorer

Data Explorer
Schema Modeler | See Also

The Data Explorer can be used to browse the Tables, Views and Stored Procedures defined in the database referred to by the current connection. You can choose which connection to view in Data Explorer by selecting the appropriate connection in the Connections Pane.

Data Explorer is used in two places in the Schema Modeler:

  1. An instance of the Data Explorer is docked to the main window of Schema Modeler. This instance always shows the currently selected connection. You can drag items from it to the Data Tables and Commands panes to create new datasets and commands, respectively.
  2. Data Explorer is also used inside the SQL Editor, which can be invoked from the Connections pane or from the Statements view of a particular data table or command. In SQL Editor, you can drag items from the Data Explorer to the SQL text window, to create new SQL queries or to use field names in the current query.
See Also

Data Tables, Commands and Connections panes,

SQL Editor, Diagramming and Modeling Support

Group

Schema Modeler

Links
Schema Modeler, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


SQL Editor

SQL Editor
Schema Modeler | See Also

The SQL Editor is a custom editor provided for simplifying SQL maintenance. It can be invoked in two ways:

  • from the Connections pane
  • from the Statements view of a particular dataset or command.
Invoking SQL Editor for manual queries

Simply right-click any connection in the Connections pane and select Open SQL Editor to open an new SQL Editor for the selected connection. You can also right-click a data table in the Data Tables pane or a table or view in the Data Explorer to open a new SQL Editor that queries that table.

You can use this instance of the SQL Editor to run any query or command that you like on the selected connection.

Invoking SQL Editor for a Statement

You can also invoke SQL Editor for a specific data table or command statement on Statements page of the Data Table Details or Command Details views. If you open SQL Editor like this, you will be editing the SQL associated with the statement in question, and any changes you make to the SQL in the editor will be applied to the statement.

Using the SQL Editor

In SQL Editor, you can drag items from the Data Explorer to the SQL text window, to create new SQL queries or to use field names in the current query:

The screenshot above shows that, having created and/or modified the SQL, you can test it by clicking on "Run as DataSet".

See Also

Data Tables, Commands and Connections panes

Data Explorer

Group

Schema Modeler

Links
Schema Modeler, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Additional Information

Contents | Index
Previous | Next
Additional Information

Please make sure to visit the RemObjects Software website at remobjects.com, where up to date information on all our products is available.

RSS feeds are also provided, to help you stay informed about new articles and product news.


FAQs

FAQs
Additional Information | See Also

Frequently asked questions (FAQs) about our products are maintained on our website and are often extended and enhanced based on feedback we receive via our newsgroups and support team.

We maintain a single FAQ database containing items for all our products and you can reach the FAQ home page via: remobjects.com/devcenter/faq

The FAQ page allows you to filter by product or category and also offers a text search facility.

Notes

If you need to refer to a numbered item, you can use a shortcut, e.g. remobjects.com?faq112 to directly access the FAQ in question.

See Also

Online Articles, Newsgroups and Getting Technical Support help topics

Group

Additional Information

Links
Additional Information, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Online Articles

Online Articles
Additional Information | See Also

RemObjects Software provides an extensive set of online articles and other resources, covering all aspects of our products in varying degrees of detail, from non-technical whitepapers over introductory articles to in-depth architecture reviews for experienced users.

The complete set of RemObjects developer resources can be accessed via our Developer Center at remobjects.com/devcenter.

See Also

FAQs, Newsgroups and Getting Technical Support help topics

Group

Additional Information

Links
Additional Information, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Getting Technical Support

Getting Technical Support
Additional Information | See Also

For more information on getting technical support for RemObjects products, please refer to the RemObjects website at remobjects.com/support.

Our goal is to help create success for you and your organization by leveraging RemObjects’ industry-leading solutions. RemObjects Support provides world class technical support, and you can email our support team at support@remobjects.com should you have any technical issues.

Paid per-incident Premium Support is also available, please visit remobjects.com?premiumsupport for details.

See Also

FAQs, Online Articles and Newsgroups help topics

Group

Additional Information

Links
Additional Information, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Newsgroups

Newsgroups
Additional Information | See Also

Support newsgroups are available via NNTP at news.remobjects.com:

  • For .NET Products:
    • remobjects.public.dataabstract.net
    • remobjects.public.hydra.net
    • remobjects.public.chrome
    • remobjects.public.sdk.net
  • For Delphi Products:
    • remobjects.public.dataabstract.delphi
    • remobjects.public.hydra.delphi
    • remobjects.public.sdk.delphi
  • Other Useful Groups:
    • remobjects.public.binaries
    • remobjects.public.bugreports
    • remobjects.public.non-tech
    • remobjects.public.suggestions

Please visit www.remobjects.com?newsgroups for more up to date information on available newsgroups and assistance for setting up newsgroup access.

See Also

FAQs, Online Articles and Getting Technical Support help topics

Group

Additional Information

Links
Additional Information, See Also
Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


Copyright Notice

Previous
Copyright Notice

Data Abstract Schema Modeler Documentation

The Software as described in this online help system, is licensed under the software license agreement distributed with the product. The software may be used or copied only in accordance with the terms of its license.

Data Abstract Schema Modeler is copyright © RemObjects Software, LLC, 2002-2007. All Rights reserved.

This help file is copyright © RemObjects Software, LLC, 2002-2007. All Rights reserved.

This help file was created using doc-o-matic. We'd like to thank toolsfactory and Markus Spoettl for their continuous support!

Please also visit our online developer center at remobjects.com/devcenter.

Copyright

No part of this help can be reproduced, stored in any retrieval system, copied or modified, transmitted in any form or by any electronic or mechanical means, including photocopying and recording for purposes other than the purchaser's personal use.

Microsoft, Windows, Visual Studio, Microsoft .NET, Internet Information Server and Personal Web Server are registered trademarks or trademarks of Microsoft Corporation.

All other brands and names mentioned in this help system are the properties of their respective owners.

RemObjects Software Trademarks

Chrome™, Data Abstract™, DebugServer™, DevCenter™, DevStudio™, EWF Server Pack™, Hydra™, Internet Pack™, Pascal Script™, RemObjects™, RemObjects Software™, RemObjects SDK™, The Infrastructure Company™ and Wolpertinger™ as well as their respective logos are trademarks or registered trademarks of RemObjects Software, LLC in the United States of America and World-Wide.

The absence of a name or logo in the above list does not constitute a waiver of any and all intellectual property rights that RemObjects Software has established in any of its product, feature, or service names or logos.

Copyright © RemObjects Software, LLC, 2002-2007. All rights reserved.


See Also

See Also
Commands Pane
See Also

Data Tables and Connections panes

Data Explorer

SQL Editor

Diagramming and Modeling Support

Copyright (c) RemObjects Software, LLC, 2002-2006. All rights reserved.


See Also

See Also
Connections Pane
See Also

Data Tables and Commands panes,

Data Explorer, SQL Editor, Diagramming and Modeling Support


See Also

See Also
Data Explorer
See Also

Data Tables, Commands and Connections panes,

SQL Editor, Diagramming and Modeling Support


See Also

See Also
Data Tables Pane
See Also

Commands Pane Connections Pane Data Explorer SQL Editor Diagramming and Modeling Support


See Also

See Also
Diagramming and Modeling Support
See Also

Relationships View help topic


See Also

See Also
FAQs
See Also

Online Articles, Newsgroups and Getting Technical Support help topics


See Also

See Also
Getting Technical Support
See Also

FAQs, Online Articles and Newsgroups help topics


See Also

See Also
Newsgroups
See Also

FAQs, Online Articles and Getting Technical Support help topics


See Also

See Also
Online Articles
See Also

FAQs, Newsgroups and Getting Technical Support help topics


See Also

See Also
Relationships View
See Also

Diagramming and Modeling Support help topic


See Also

See Also
Schema Modeler Overview
See Also

Online articles:

DA03 - Introduction to Schemas

DA14 - Introducing Diagramming with Data Abstract


See Also

See Also
SQL Editor
See Also

Data Tables, Commands and Connections panes

Data Explorer


Contents

Contents
Schema Modeler
Schema Modeler Overview
Data Tables Pane
Commands Pane
Detail Pane
Data Table Details
Command Details
Connection Details
Relationships View
Data Dictionary Editor
Update Rules View
Diagramming and Modeling Support
Schema Modeler Welcome Page
Connections Pane
Data Explorer
SQL Editor
Additional Information
FAQs
Online Articles
Getting Technical Support
Newsgroups
Copyright Notice


Index

Index
A | C | D | F | G | N | O | R | S | U
A
Additional Information
C
Command Details
Commands Pane
Connection Details
Connections Pane
Copyright Notice
D
Data Dictionary Editor
Data Explorer
Data Table Details
Data Tables Pane
Detail Pane
Diagramming and Modeling Support
F
FAQs
G
Getting Technical Support
N
Newsgroups
O
Online Articles
R
Relationships View
S
Schema Modeler
Schema Modeler Overview
Schema Modeler Welcome Page
SQL Editor
U
Update Rules View


Welcome